diff -arcN emacs-18.55/src/xdisp.c nemacs-3.3.2/src/xdisp.c
*** emacs-18.55/src/xdisp.c	Thu Apr 27 05:13:59 1989
--- nemacs-3.3.2/src/xdisp.c	Wed Jun  6 03:18:08 1990
***************
*** 1,3 ****
--- 1,15 ----
+ /* 87.4.30  modified by K.Handa */
+ /* 87.7.12  modified by K.Handa */
+ /* 88.2.1   modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.5.30  modified for Nemacs Ver.2.1 by K.Handa */
+ /* 89.3.5   modified for Nemacs Ver.3.0 by K.Handa */
+ /* 89.11.18 modified for Nemacs Ver.3.2 by K.Handa */
+ /* 89.11.24 modified for attribute of characters by K.Handa */
+ /* 90.3.2   modified for Nemacs Ver.3.3.1 by S.Tomura
+ 	'C' in mode-line-format */
+ /* 90.3.11  modified for Nemacs Ver.3.3.2 by A.Shibata
+ 	Kanji display at left edge of screen when scrolled left. */
+ 
  /* Display generation from window structure and buffer text.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 31,36 ****
--- 43,51 ----
  #include "indent.h"
  #include "commands.h"
  #include "macros.h"
+ #ifdef NEMACS  /* 87.6.5  by K.Handa */
+ #include "kanji.h"
+ #endif
  
  extern int interrupt_input;
  
***************
*** 1167,1172 ****
--- 1182,1192 ----
    return 1;
  }
  
+ /* patch for attribute by K.Handa  89.11.24 */
+ #define APOS(amark) \
+   ((XTYPE(amark) == Lisp_Marker && XMARKER (amark)->buffer) \
+    ? Fmarker_position (amark) : end)
+ 
  /* Display one line of window w, starting at position `start' in w's buffer.
   Display starting at horizontal position `hpos',
    which is normally zero or negative.
***************
*** 1219,1227 ****
--- 1239,1259 ----
        ? XINT (bf_cur->selective_display)
  	: !NULL (bf_cur->selective_display) ? -1 : 0;
    int selective_e = selective && !NULL (bf_cur->selective_display_ellipses);
+ #ifdef NEMACS  /* 87.6.9  by K.Handa */
+   int kflag = !NULL(bf_cur->kanji_flag);
+ #endif
+ /* patch for attribute of characters by K.Handa  89.11.21 */
+   char attribute_bits = 0;
+   char *attrp, *attrstartp;
+   Lisp_Object underline, umark, inverse, imark;
+   int upos, ipos;
+ /* end of patch */
  
    hpos += XFASTINT (w->left);
    line = get_display_line (vpos, XFASTINT (w->left));
+ #ifdef NEMACS  /* 89.3.9  by K.Handa */
+   line->kanji_flag = kflag;
+ #endif
    if (tab_width <= 0 || tab_width > 20) tab_width = 8;
  
    if (w == XWINDOW (minibuf_window) && start == 1
***************
*** 1240,1245 ****
--- 1272,1313 ----
    startp = line->body + XFASTINT (w->left);
    endp = startp + width;
  
+ /* patch for attribute by K.Handa 89.11.24 */
+   attrp = line->attribute + (p1 - line->body);
+   attrstartp = line->attribute + (startp - line->body);
+ 
+   if (!NULL(bf_cur->underlined_region)
+       && XTYPE (bf_cur->underlined_region) == Lisp_Cons) {
+     int i = XINT(Fcar (bf_cur->underlined_region)) - 1;
+     underline = Fcdr (bf_cur->underlined_region);
+     umark = Fcar (underline);
+     while (i-- && !NULL(umark) && start >= (upos = APOS (umark))) {
+       underline = Fcdr (underline);
+       umark = Fcar (underline);
+       attribute_bits ^= ATTR_UNDERLINE;
+     }
+     if (NULL(underline)) upos = end;
+   }  else {
+     underline = umark = Qnil;
+     upos = end;
+   }
+   if (!NULL(bf_cur->inversed_region)
+       && XTYPE (bf_cur->inversed_region) == Lisp_Cons) {
+     int i = XINT(Fcar (bf_cur->inversed_region)) - 1;
+     inverse = Fcdr (bf_cur->inversed_region);
+     imark = Fcar (inverse);
+     while (i-- && !NULL(imark) && start >= (ipos = APOS (imark))) {
+       inverse = Fcdr (inverse);
+       imark = Fcar (inverse);
+       attribute_bits ^= ATTR_INVERSE;
+     }
+     if (NULL(inverse)) ipos = end;
+   }  else {
+     inverse = imark = Qnil;
+     ipos = end;
+   }
+ /* end of patch */
+ 
    /* Loop generating characters.
     Stop at end of buffer, before newline,
     or if reach or pass continuation column.  */
***************
*** 1266,1271 ****
--- 1334,1359 ----
  
  	  p = &CharAt (pos);
  	}
+ /* patch for attribute of characters by K.Handa 89.11.21 */
+       while (pos >= upos) {
+ 	attribute_bits ^= ATTR_UNDERLINE;
+ 	if (!NULL (underline)) {
+ 	  underline = Fcdr (underline);
+ 	  umark = Fcar (underline);
+ 	  upos = APOS (umark);
+ 	} else
+ 	  upos = end;
+       }
+       while (pos >= ipos) {
+ 	attribute_bits ^= ATTR_INVERSE;
+ 	if (!NULL (inverse)) {
+ 	  inverse = Fcdr (inverse);
+ 	  imark = Fcar (inverse);
+ 	  ipos = APOS (imark);
+ 	} else
+ 	  ipos = end;
+       }
+ /* end of patch */
        c = *p++;
        if (c >= 040 && c < 0177)
  	{
***************
*** 1319,1324 ****
--- 1407,1428 ----
  	    }
  	  break;
  	}
+ #ifdef NEMACS  /* 87.4.30, 88.1.8, 88.5.30, 89.3.9, 90.3.3  by K.Handa */
+       else if (kflag && EUC_P(c) && pos < end - 1 && EUC_P(CharAt(pos+1)))
+ 	{
+ 	  if (p1 >= startp)
+ 	    *p1 = c;
+ 	  p1++;
+ 	  pos++;
+ 	  p = &CharAt (pos);
+ 	  if (p1 > startp)
+ 	    *p1 = *p;		/* 90.3.11 by A.Shibata */
+ 	  else if (p1 == startp)
+ 	    *p1 = ' ';
+ 	  p1++;
+ 	  *p++;			/* 90.3.11 by A.Shibata */
+ 	}
+ #endif  /* NEMACS */
        else if (c < 0200 && ctl_arrow)
  	{
  	  if (p1 >= startp)
***************
*** 1343,1348 ****
--- 1447,1458 ----
  	    *p1 = (7 & c) + '0';
  	  p1++;
  	}
+ /* patch for attribute by K.Handa  89.11.24 */
+       while (attrp < line->attribute + (p1 - line->body)) {
+ 	if (attrstartp <= attrp) *attrp = attribute_bits;
+ 	attrp++;
+       }
+ /* end of patch */
        pos++;
      }
  
***************
*** 1362,1367 ****
--- 1472,1490 ----
        pos--;
        /* but at a negative hpos, to skip the columns output on this line.  */
        val.hpos += p1prev - endp;
+ #ifdef NEMACS  /* 88.1.10  by K.Handa */
+       if (line->body + hpos < endp)
+ /* 88.5.30, 89.3.10  by K.Handa */
+       if (kflag && EUC_P(*(unsigned char *)p1prev)
+ 	  && pos < end && EUC_P(*(unsigned char *)(p1prev+1))) {
+ 	*p1prev = '\\';
+ 	val.hpos++;
+ 	pos--;		/* Start the next line with that same 2-byte char */
+ 	lastpos -= 2;
+ 	if (point == pos)
+ 	  point_vpos = -1;	/* point must not be on this line */
+       }
+ #endif  /* NEMACS */
        /* Keep in this line everything up to the continuation column.  */
        p1 = endp;
      }
***************
*** 1436,1441 ****
--- 1559,1567 ----
    /* If hscroll and line not empty, insert truncation-at-left marker */
    if (hscroll && lastpos != start)
      {
+ #ifdef NEMACS  /* 89.3.9  by K.Handa */
+       if (!kflag || !EUC_P((unsigned char)*startp))
+ #endif
        *startp = '$';
        if (p1 <= startp)
  	p1 = startp + 1;
***************
*** 1744,1752 ****
--- 1870,1904 ----
  {
    Lisp_Object obj = Qnil;
    char *tbuf = decode_mode_spec_buf;
+   char *NSJE = "NSJE";
  
    switch (c)
      {
+ #ifdef NEMACS  /* 88.2.1  by K.Handa */
+     case 'c':
+       tbuf[0] = NULL(bf_cur->kanji_fileio_code)
+ 	? '-'
+ 	: NSJE[XFASTINT (bf_cur->kanji_fileio_code) % 4];
+       tbuf[1] = NSJE[kanji_input_code % 4];
+       tbuf[2] = NSJE[kanji_display_code % 4];
+ /* patch by the idea of enami@ptgd.sony.co.jp 1989.11.19 */
+       obj = Fget_buffer_process(Fcurrent_buffer ());
+       if (!NULL(obj)) obj = Fprocess_kanji_code(obj);
+       tbuf[3] = (NULL(obj)) ? '-' : NSJE[XFASTINT(obj)];
+       tbuf[4] = 0;
+       return tbuf;
+ /* 90.3.2  patch by S.Tomura */
+     case 'C':
+       tbuf[0] = NULL(bf_cur->kanji_fileio_code)
+ 	? '-'
+ 	: NSJE[XFASTINT (bf_cur->kanji_fileio_code) % 4];
+       obj = Fget_buffer_process(Fcurrent_buffer ());
+       if (!NULL(obj)) obj = Fprocess_kanji_code(obj);
+       tbuf[1] = (NULL(obj)) ? '-' : NSJE[XFASTINT(obj)];
+       tbuf[2] = 0;
+       return tbuf;
+ /* end of patch */
+ #endif
      case 'b': 
        obj = bf_cur->name;
        if (maxwidth >= 3 && XSTRING (obj)->size > maxwidth)
***************
*** 1883,1888 ****
--- 2035,2045 ----
    register unsigned char *end;
    unsigned char *p1start = (unsigned char *) line->body + hpos;
    int window_width = XFASTINT (w->width);
+ #ifdef NEMACS  /* 89.3.5  by K.Handa */
+   int kflag = !NULL(bf_cur->kanji_flag);
+ 
+   line->kanji_flag = kflag;
+ #endif
  
    if (tab_width <= 0 || tab_width > 20) tab_width = 8;
  
***************
*** 1918,1923 ****
--- 2075,2097 ----
  	    }
  	  while ((p1 - start + hscroll - (hscroll > 0)) % tab_width);
  	}
+ #ifdef NEMACS  /* 87.4.30, 87.7.12, 89.11.18  by K.Handa */
+       else if (kflag && EUC_P(c) && EUC_P(*string))
+ 	{
+ 	  if (p1 < start) {
+ 	    p1++;
+ 	    if (p1++ == start) *start = ' ';
+ 	    string++;
+ 	  } else if (p1 < end - 1) {
+ 	    *p1++ = c;
+ 	    *p1++ = *string++;
+ 	    }
+ 	  else {
+ 	    *p1++ = truncate ? truncate : ' ';
+ 	    string--;
+ 	  }
+ 	}
+ #endif  /* NEMACS */
        else if (c < 0200 && buffer_defaults.ctl_arrow)
  	{
  	  if (p1 >= start)
diff -arcN emacs-18.55/src/xfns.c nemacs-3.3.2/src/xfns.c
*** emacs-18.55/src/xfns.c	Mon Aug 14 04:53:07 1989
--- nemacs-3.3.2/src/xfns.c	Wed Jun  6 03:18:28 1990
***************
*** 1,3 ****
--- 1,6 ----
+ /* 88.1.15  modified for Nemacs Ver.2.0  by K.Handa */
+ /* 88.3.28  modified for Nemacs Ver.3.0  by K.Handa */
+ 
  /* Functions for the X window system.
     Copyright (C) 1985, 1986, 1987 Free Software Foundation.
  
***************
*** 113,118 ****
--- 116,124 ----
  extern int (*handler) ();
  
  extern FontInfo *fontinfo;
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+ extern FontInfo *kfontinfo;
+ #endif
  
  extern int PendingExposure;
  extern char *default_window;
***************
*** 121,126 ****
--- 127,135 ----
  extern Cursor EmacsCursor;
  extern short MouseCursor[], MouseMask[];
  extern char *XXcurrentfont;
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+ extern char *XXcurrentkfont;
+ #endif
  extern int informflag;
  
  extern int WindowMapped;
***************
*** 544,549 ****
--- 553,596 ----
    return Qnil;
  }
  
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+ DEFUN ("x-set-kfont", Fx_set_kfont, Sx_set_kfont, 1, 1, "sKanji Font Name: ",
+       "At initialization sets the kanji font to be used for the X window.")
+   (arg)
+      Lisp_Object arg;
+ {
+   register char *newfontname;
+ 	
+   CHECK_STRING (arg, 1);
+   check_xterm ();
+ 
+   newfontname = (char *) xmalloc (XSTRING (arg)->size + 1);
+   bcopy (XSTRING (arg)->data, newfontname, XSTRING (arg)->size + 1);
+   if (XSTRING (arg)->size == 0)
+     /* XOpenFont ("") gets a badarg error rather than a badfont error.
+        I believe this is an X bug.
+        In emacs, badarg errors cause emacs to die, whilst badfont errors
+        are caught.  This kludge prevents us from dying.
+      */
+     goto badfont;
+ 
+   if (!XNewKFont (newfontname))
+     {
+       free (XXcurrentkfont);
+       XXcurrentkfont = newfontname;
+       return Qt;
+     }
+   else
+     {
+     badfont:
+       error ("Kanji font \"%s\" is not defined", newfontname);
+       free (newfontname);
+     }
+ 
+   return Qnil;
+ }
+ #endif NEMACS
+ 
  DEFUN ("x-set-window-edges", Fx_set_window_edges, Sx_set_window_edges, 4, 4,
    "nNumber of Columns: \nnNumber of Rows: \nnX Offset in Pixels: \n\
  nY Offset in Pixels: ",
***************
*** 1005,1010 ****
--- 1052,1060 ----
  jmp_buf dispenv;
  Display *OldDisplay;
  FontInfo *OldFontInfo;
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+ FontInfo *OldKFontInfo;
+ #endif
  Window OldWindow;
  
  XRestoreDisplay ()
***************
*** 1048,1053 ****
--- 1098,1107 ----
   /*       free (&newdisplayname[0]); */
         if (fontinfo)
  	 XCloseFont (fontinfo);
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+        if (kfontinfo)
+ 	 XCloseFont (kfontinfo);
+ #endif
         if (XXwindow)
  	 XDestroyWindow (XXwindow);
         if (XXdisplay)
***************
*** 1054,1059 ****
--- 1108,1116 ----
  	 XCloseDisplay (XXdisplay);
         XXdisplay = OldDisplay;
         fontinfo = OldFontInfo;
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+        kfontinfo = OldKFontInfo;
+ #endif
         XXwindow = OldWindow;
         EmacsCursor = OldEmacsCursor;
         XIOErrorHandler (handler);
***************
*** 1066,1074 ****
--- 1123,1137 ----
         OldEmacsCursor = EmacsCursor;
         OldDisplay = XXdisplay;
         OldFontInfo = fontinfo;
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+        OldKFontInfo = kfontinfo;
+ #endif
         OldWindow = XXwindow;
         XXwindow = 0;
         fontinfo = 0;
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+        kfontinfo = 0;
+ #endif
         XXdisplay = 0;
       }
     XXdisplay = XOpenDisplay (newdisplayname);
***************
*** 1082,1087 ****
--- 1145,1157 ----
       {
         longjmp (dispenv, "Bad font");
       }
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+    kfontinfo = XOpenFont (XXcurrentkfont);
+    if (!kfontinfo)
+      {
+        longjmp (dispenv, "Bad kanji font");
+      }
+ #endif  /* not NEMACS */
     /* pixelwidth and pixelheight are correct*/
     XXwindow = XCreateWindow (RootWindow,
  			     XXxoffset,
***************
*** 1131,1136 ****
--- 1201,1209 ----
    WindowMapped = 1;
    XSetDisplay (OldDisplay);
    XCloseFont (OldFontInfo);
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+   XCloseFont (OldKFontInfo);
+ #endif
    XFreeCursor (OldEmacsCursor);
    XDestroyWindow (OldWindow);
    XSetDisplay (XXdisplay);
***************
*** 1366,1371 ****
--- 1439,1447 ----
    defsubr (&Sx_flip_color);
    defsubr (&Sx_set_icon);
    defsubr (&Sx_set_font);
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+   defsubr (&Sx_set_kfont);
+ #endif
    defsubr (&Sx_set_window_edges);
    defsubr (&Scoordinates_in_window_p);
    defsubr (&Sx_mouse_events);
diff -arcN emacs-18.55/src/xterm.c nemacs-3.3.2/src/xterm.c
*** emacs-18.55/src/xterm.c	Thu Dec 29 13:09:23 1988
--- nemacs-3.3.2/src/xterm.c	Wed Jun  6 03:18:12 1990
***************
*** 1,3 ****
--- 1,6 ----
+ /* 88.1.15  modified for Nemacs Ver.2.0 by K.Handa */
+ /* 89.3.28  modified for Nemacs Ver.3.0 by K.Handa */
+ 
  /* X Communication module for terminals which understand the X protocol.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 78,83 ****
--- 81,89 ----
  /* Allow config to specify default font.  */
  #ifndef X_DEFAULT_FONT
  #define X_DEFAULT_FONT "vtsingle"
+ #ifdef NEMACS  /* 89.3.28  by K.Handa */
+ #define X_DEFAULT_FONT "8x16kana"
+ #define X_DEFAULT_KFONT "16x16krom"
  #endif
  
  #define min(a,b) ((a)<(b) ? (a) : (b))
***************
*** 97,102 ****
--- 103,111 ----
  Bitmap XXIconMask;
  
  char *XXcurrentfont;
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ char *XXcurrentkfont;
+ #endif
  char *default_window;
  int informflag;
  extern struct display_line *DesiredScreen[], *PhysScreen[];
***************
*** 142,147 ****
--- 151,159 ----
  
  Display *XXdisplay;
  FontInfo *fontinfo;
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ FontInfo *kfontinfo;
+ #endif
  Window XXwindow;
  Cursor EmacsCursor;
  
***************
*** 449,460 ****
--- 461,481 ----
      {
        return;
      }
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+   XKText (XXwindow,
+ #else
    XText (XXwindow,
+ #endif
  	 (tempX * fontinfo->width+XXInternalBorder),
  	 (tempY * fontinfo->height+XXInternalBorder),
  	 &ActiveScreen[tempY + 1]->body[tempX],
  	 numcols,
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 	 fontinfo,
+ 	 kfontinfo,
+ #else
  	 fontinfo->id,
+ #endif
  	 (tempHL ? back : fore),
  	 (tempHL ? fore : back));
  }
***************
*** 489,500 ****
--- 510,530 ----
      {
        if (end != start - 1)
  	{
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 	  XKText (XXwindow,
+ #else
  	  XText (XXwindow,
+ #endif
  		 (cursX * fontinfo->width+XXInternalBorder),
  		 (cursY * fontinfo->height+XXInternalBorder),
  		 start,
  		 end + 1 - start,
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 		 fontinfo,
+ 		 kfontinfo,
+ #else
  		 fontinfo->id,
+ #endif
  		 (CurHL ? back : fore),
  		 (CurHL ? fore : back));
  	  XTtopos (cursY, cursX + end - start + 1);
***************
*** 518,529 ****
--- 548,568 ----
  	}
        if (end >= start)
  	{
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 	   XKText (XXwindow,
+ #else
  	   XText (XXwindow,
+ #endif
  		 (VisibleX * fontinfo->width+XXInternalBorder),
  		 (VisibleY * fontinfo->height+XXInternalBorder),
  		 start,
  		 ((end - start) + 1),
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 		 fontinfo,
+ 		 kfontinfo,
+ #else
  		 fontinfo->id,
+ #endif
  		 (CurHL ? back : fore),
  		 (CurHL ? fore : back));
  	  VisibleX = VisibleX + (end - start) + 1;
***************
*** 651,670 ****
--- 690,727 ----
      {
        if (CursorExists)
  	{
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 	  XKText (XXwindow,
+ #else
  	  XText (XXwindow,
+ #endif
  		 VisibleX * fontinfo->width+XXInternalBorder,
  		 VisibleY * fontinfo->height+XXInternalBorder,
  		 &ActiveScreen[VisibleY + 1]->body[VisibleX], 1,
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 		 fontinfo,
+ 		 kfontinfo,
+ #else
  		 fontinfo->id,
+ #endif
  		 fore, back);
  	}
        else
  	{
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 	  XKText (XXwindow,
+ #else
  	  XText (XXwindow,
+ #endif
  		 VisibleX * fontinfo->width+XXInternalBorder,
  		 VisibleY * fontinfo->height+XXInternalBorder,
  		 &ActiveScreen[VisibleY + 1]->body[VisibleX], 1,
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 		 fontinfo,
+ 		 kfontinfo,
+ #else
  		 fontinfo->id,
+ #endif
  		 back, curs);
  	}
      }
***************
*** 1071,1076 ****
--- 1128,1136 ----
  	      /* is pending */
  	      break;
  	    }
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+ 	  PendingExposure = 1;
+ #else  /* not NEMACS */
  	  loadxrepbuffer (&XXEvent, &XXqueue);
  	  if (XXqueue.rindex == XXqueue.windex)
  	    {
***************
*** 1083,1088 ****
--- 1143,1149 ----
  	    {
  	      PendingExposure = 1;
  	    }
+ #endif  /* not NEMACS */
  	  break;
  	case ExposeCopy:	/* For ExposeCopy sync */
  	  /* will block all outgoing */
***************
*** 1428,1433 ****
--- 1489,1500 ----
    if (temp_font == 0) temp_font = X_DEFAULT_FONT;
    XXcurrentfont = (char *) xmalloc (strlen (temp_font) + 1);
    strcpy (XXcurrentfont, temp_font);
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+   temp_font  = XGetDefault (progname,"KanjiFont");
+   if (temp_font == 0) temp_font = X_DEFAULT_KFONT;
+   XXcurrentkfont = (char *) xmalloc (strlen (temp_font) + 1);
+   strcpy (XXcurrentkfont, temp_font);
+ #endif  /* NEMACS */
  
    /* If user has specified a special keymap for use with Emacs, use it. */
    {
***************
*** 1567,1572 ****
--- 1634,1646 ----
        fprintf (stderr, "Memory allocation failure.\n");
        exit (-150);
      }
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+   if (XXcurrentkfont == (char *) 0)
+     {
+       fprintf (stderr, "Memory allocation failure.\n");
+       exit (-150);
+     }
+ #endif  /* NEMACS */
    default_window = "=80x24+0+0";
  /* RMS: XTread_socket does not have an interface suitable
     for being a signal handler.  In any case, the SIGIO handler is
***************
*** 1581,1586 ****
--- 1655,1668 ----
        fprintf (stderr, "No font\n");
        exit (-98);
      }
+ #ifdef NEMACS  /* 87.7.4  by T.Takada */
+   kfontinfo = XOpenFont (XXcurrentkfont);
+   if (kfontinfo == (FontInfo *) 0)
+     {
+       fprintf (stderr, "No Kanji font\n");
+       exit (-98);
+     }
+ #endif
    pixelwidth = screen_width * fontinfo->width + 2 * XXInternalBorder;
    pixelheight = screen_height * fontinfo->height + 2 * XXInternalBorder;
    XXwindow = XCreateWindow (RootWindow,
***************
*** 1723,1728 ****
--- 1805,1844 ----
    return 0;
  }
  
+ #ifdef NEMACS  /* 87.7.9  by T.Takada */
+ XNewKFont (newname)
+      register char *newname;
+ {
+   FontInfo *temp;
+   int mask = sigblock (sigmask (SIGIO));
+   XFlush ();
+   if (XXdebug)
+     fprintf (stderr, "Request id is %d\n", XXdisplay->request);
+   temp = XOpenFont (newname);
+   if (temp == (FontInfo *) 0)
+     {
+       sigsetmask (mask);
+       if (QLength () > 0)
+ 	{
+ 	    kill (XXpid, SIGIO);
+ 	}
+       return -1;
+     }
+   XCloseFont (kfontinfo);
+   kfontinfo = temp;
+   XSetResizeHint (XXwindow, 2*XXInternalBorder, 2*XXInternalBorder,
+ 		  /* fontinfo->width * 1, fontinfo->height * 1, */
+ 		  fontinfo->width, fontinfo->height);
+   XSetWindowSize (screen_height, screen_width);
+   sigsetmask (mask);
+   if (QLength () > 0)
+     {
+ 	kill (XXpid, SIGIO);
+     }
+   return 0;
+ }
+ #endif  /* NEMACS */
+ 
  XFlipColor ()
  {
    Pixmap temp;
***************
*** 1917,1921 ****
--- 2033,2080 ----
    Xxrepbuffer.windex = 0;
    Xxrepbuffer.rindex = 0;
  }
+ 
+ #ifdef NEMACS  /* 87.7.4  T.Takada */
+ static char kanjibuf[MScreenWidth];
+ XKText(w, x, y, str, len, afont, kfont, fore, back)
+ Window w;
+ int x, y;
+ char *str;
+ int len;
+ FontInfo *afont, *kfont;
+ int fore, back;
+ {
+ #define KAN(c) (0x80 & (c))
+ 
+   char *sp, *bufp;
+   int n;
+   FontInfo *f;
+ 
+   sp = str, n = len;
+   while (len > 0) {
+     if (KAN(*str)) {
+       bufp = kanjibuf;
+       while (len > 0 && KAN(*str)) --len, *bufp++ = *str++ & 0x7f;
+       n -= len;
+       if (n % 2) --len, n++, *bufp++ = *str++ & 0x7f;
+       XText(w, x, y, kanjibuf, n, kfont->id, fore, back);
+       f = afont;
+     }
+     else {
+       while(len > 0 && !KAN(*str)) --len, str++;
+       n -= len;
+       XText(w, x, y, sp, n, afont->id, fore, back);
+       f = kfont;
+     }
+     x += afont->width * n;
+     sp = str, n = len;
+   }
+   n -= len;
+   if (n > 0) {
+     if ((f == kfont) && (n % 2)) n++, *bufp = *str;
+     XText(w, x, y, ((f == kfont) ? kanjibuf : sp), n, f, fore, back);
+   }
+ }
+ #endif
  
  #endif /* HAVE_X_WINDOWS */
diff -arcN emacs-18.55/src/ymakefile nemacs-3.3.2/src/ymakefile
*** emacs-18.55/src/ymakefile	Sat Jun 17 11:17:09 1989
--- nemacs-3.3.2/src/ymakefile	Wed Jun  6 03:19:11 1990
***************
*** 1,3 ****
--- 1,13 ----
+ /* 87.7.15  modified by K.Handa */
+ /* 87.6.9   modified by K.Handa */
+ /* 88.1.15  modified for Nemacs Ver.2.0 by K.Handa */
+ /* 89.11.20 modified for Nemacs Ver.3.2 by K.Handa */
+ /* 89.12.12 modified for Nemacs Ver.3.2.1 by K.Handa
+ 	'make-docfile' concerns kanji.o and wnnfns.o. */
+ /* 90.2.27  modified for Nemacs Ver.3.3.1 by K.Handa
+ 	add dependency on puresize.h and nconfig.h to alloc.c and data.c
+ 	change definition of WNNLIB and WNNINC */
+ 
  /* Makefile for GNU Emacs.
     Copyright (C) 1985, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 30,35 ****
--- 40,53 ----
  #define NO_SHORTNAMES
  #include "config.h"
  
+ /* 90.2.27  patch by K.Handa */
+ #ifdef NEMACS  /* 90.2.27  by K.Handa */
+ #include "nconfig.h"
+ WNNLIB = LIBWNN
+ WNNINC = INCWNN
+ #endif
+ /* end of patch */
+ 
  /* Use HAVE_X11 as an alias for X11 in this file
     to avoid problems with X11 as a subdirectory name
     in -I and other such options which pass through this file. */
***************
*** 200,205 ****
--- 218,238 ----
  #define UNEXEC unexec.o
  #endif
  
+ #ifdef NEMACS  /* 89.3.23, 90.2.28  by K.Handa */
+ KANJI_H = kanji.h
+ #ifdef WNN4V3
+ NOBJ = kanji.o wnnfns.o
+ #else   /* not WNN4V3 */
+ #ifdef WNN3
+ NOBJ = kanji.o wnnfns.o
+ #else  /* not WNN4V3 nor WNN3 */
+ NOBJ = kanji.o
+ #endif  /* not WNN4V3 nor WNN3 */
+ #endif
+ #else   /* not NEMACS */
+ KANJI_H =
+ #endif  /* not NEMACS */
+ 
  /* lastfile must follow all files
     whose initialized data areas should be dumped as pure by dump-emacs. */
  obj=    dispnew.o scroll.o xdisp.o window.o \
***************
*** 212,217 ****
--- 245,253 ----
  	eval.o fns.o print.o lread.o \
  	abbrev.o syntax.o UNEXEC mocklisp.o bytecode.o \
  	process.o callproc.o $(environobj) \
+ #ifdef NEMACS  /* 89.12.11  by K.Handa */
+ 	$(NOBJ) \
+ #endif
  	doprnt.o
  
  #ifdef TERMINFO
***************
*** 240,246 ****
--- 276,286 ----
  
  /* define otherobj as list of object files that make-docfile
     should not be told about.  */
+ #ifdef NEMACS  /* 90.2.28  by K.Handa */
+ otherobj= $(termcapobj) lastfile.o $(mallocobj) $(WNNLIB)
+ #else
  otherobj= $(termcapobj) lastfile.o $(mallocobj)
+ #endif
  
  /* List of Lisp files loaded into the dumped Emacs. */
  lisp=	${lispdir}simple.elc ${lispdir}help.elc \
***************
*** 252,257 ****
--- 292,300 ----
  	${lispdir}text-mode.elc ${lispdir}fill.elc \
  	${lispdir}c-mode.elc ${lispdir}isearch.elc \
  	${lispdir}replace.elc ${lispdir}abbrev.elc \
+ #ifdef NEMACS  /* 87.7.15  by K.Handa */
+ 	${lispdir}kanji.elc \
+ #endif
  	${lispdir}buff-menu.elc ${lispdir}subr.elc
  
  /* just to be sure the sh is used */
***************
*** 378,386 ****
     and so rarely changed in ways that do require any.  */
  
  abbrev.o : abbrev.c buffer.h commands.h config.h 
! buffer.o : buffer.c syntax.h buffer.h commands.h window.h config.h 
  callint.o : callint.c window.h commands.h buffer.h config.h 
! callproc.o : callproc.c paths.h buffer.h commands.h config.h 
  casefiddle.o : casefiddle.c syntax.h commands.h buffer.h config.h 
  cm.o : cm.c cm.h termhooks.h config.h
  cmds.o : cmds.c syntax.h buffer.h commands.h config.h 
--- 421,429 ----
     and so rarely changed in ways that do require any.  */
  
  abbrev.o : abbrev.c buffer.h commands.h config.h 
! buffer.o : buffer.c syntax.h buffer.h commands.h window.h config.h $(KANJI_H)
  callint.o : callint.c window.h commands.h buffer.h config.h 
! callproc.o : callproc.c paths.h buffer.h commands.h config.h $(KANJI_H)
  casefiddle.o : casefiddle.c syntax.h commands.h buffer.h config.h 
  cm.o : cm.c cm.h termhooks.h config.h
  cmds.o : cmds.c syntax.h buffer.h commands.h config.h 
***************
*** 387,406 ****
  crt0.o : crt0.c config.h
  	$(CC) -c $(CFLAGS) C_SWITCH_ASM crt0.c
  dired.o : dired.c commands.h buffer.h config.h 
! dispnew.o : dispnew.c commands.h window.h buffer.h dispextern.h termchar.h termopts.h cm.h config.h
  doc.o : doc.c buffer.h config.h paths.h
  doprnt.o : doprnt.c
  editfns.o : editfns.c window.h buffer.h config.h 
! emacs.o : emacs.c commands.h config.h 
  #ifdef MAINTAIN_ENVIRONMENT
  environ.o : environ.c buffer.h commands.h config.h
  #endif MAINTAIN_ENVIRONMENT
! fileio.o : fileio.c window.h buffer.h config.h 
  filelock.o : filelock.c buffer.h paths.h config.h
  filemode.o : filemode.c 
! indent.o : indent.c window.h indent.h buffer.h config.h termchar.h termopts.h
  insdel.o : insdel.c window.h buffer.h config.h 
! keyboard.o : keyboard.c termchar.h termhooks.h termopts.h buffer.h commands.h window.h macros.h config.h 
  keymap.o : keymap.c buffer.h commands.h config.h 
  lastfile.o : lastfile.c 
  macros.o : macros.c window.h buffer.h commands.h macros.h config.h
--- 430,452 ----
  crt0.o : crt0.c config.h
  	$(CC) -c $(CFLAGS) C_SWITCH_ASM crt0.c
  dired.o : dired.c commands.h buffer.h config.h 
! dispnew.o : dispnew.c commands.h window.h buffer.h dispextern.h termchar.h termopts.h cm.h config.h $(KANJI_H)
  doc.o : doc.c buffer.h config.h paths.h
  doprnt.o : doprnt.c
  editfns.o : editfns.c window.h buffer.h config.h 
! emacs.o : emacs.c commands.h config.h nconfig.h
  #ifdef MAINTAIN_ENVIRONMENT
  environ.o : environ.c buffer.h commands.h config.h
  #endif MAINTAIN_ENVIRONMENT
! fileio.o : fileio.c window.h buffer.h config.h $(KANJI_H)
  filelock.o : filelock.c buffer.h paths.h config.h
  filemode.o : filemode.c 
! indent.o : indent.c window.h indent.h buffer.h config.h termchar.h termopts.h $(KANJI_H)
  insdel.o : insdel.c window.h buffer.h config.h 
! #ifdef NEMACS
! kanji.o : kanji.c config.h nconfig.h $(KANJI_H)
! #endif
! keyboard.o : keyboard.c termchar.h termhooks.h termopts.h buffer.h commands.h window.h macros.h config.h $(KANJI_H)
  keymap.o : keymap.c buffer.h commands.h config.h 
  lastfile.o : lastfile.c 
  macros.o : macros.c window.h buffer.h commands.h macros.h config.h
***************
*** 408,418 ****
  marker.o : marker.c buffer.h config.h 
  minibuf.o : minibuf.c syntax.h window.h buffer.h commands.h config.h 
  mocklisp.o : mocklisp.c buffer.h config.h
! process.o : process.c process.h buffer.h window.h termhooks.h termopts.h commands.h config.h 
  regex.o : regex.c syntax.h buffer.h config.h regex.h 
  scroll.o : scroll.c termchar.h config.h dispextern.h
  search.o : search.c regex.h commands.h buffer.h syntax.h config.h 
! syntax.o : syntax.c syntax.h buffer.h commands.h config.h 
  sysdep.o : sysdep.c config.h dispextern.h termhooks.h termchar.h termopts.h window.h
  term.o : term.c termchar.h termhooks.h termopts.h config.h cm.h
  termcap.o : termcap.c config.h
--- 454,464 ----
  marker.o : marker.c buffer.h config.h 
  minibuf.o : minibuf.c syntax.h window.h buffer.h commands.h config.h 
  mocklisp.o : mocklisp.c buffer.h config.h
! process.o : process.c process.h buffer.h window.h termhooks.h termopts.h commands.h config.h $(KANJI_H)
  regex.o : regex.c syntax.h buffer.h config.h regex.h 
  scroll.o : scroll.c termchar.h config.h dispextern.h
  search.o : search.c regex.h commands.h buffer.h syntax.h config.h 
! syntax.o : syntax.c syntax.h buffer.h commands.h config.h $(KANJI_H)
  sysdep.o : sysdep.c config.h dispextern.h termhooks.h termchar.h termopts.h window.h
  term.o : term.c termchar.h termhooks.h termopts.h config.h cm.h
  termcap.o : termcap.c config.h
***************
*** 421,441 ****
  undo.o : undo.c buffer.h commands.h undo.h config.h 
  UNEXEC : config.h
  window.o : window.c indent.h commands.h window.h buffer.h config.h termchar.h
! xdisp.o : xdisp.c macros.h commands.h indent.h buffer.h dispextern.h termchar.h window.h config.h 
  xfns.o : xfns.c xterm.h window.h config.h
  xmenu.o : xmenu.c xterm.h window.h config.h
  xterm.o : xterm.c xterm.h termhooks.h termopts.h termchar.h \
!  dispextern.h config.h sink.h sinkmask.h
  
! x11fns.o : x11fns.c window.h x11term.h dispextern.h termchar.h config.h
  x11term.o : x11term.c x11term.h termhooks.h termopts.h termchar.h \
   dispextern.h config.h sink.h sinkmask.h
  
  /* The files of Lisp proper */
  
! alloc.o : alloc.c window.h buffer.h config.h 
  bytecode.o : bytecode.c buffer.h config.h 
! data.o : data.c buffer.h config.h 
  eval.o : eval.c commands.h config.h
  fns.o : fns.c buffer.h commands.h config.h
  print.o : print.c process.h window.h buffer.h config.h 
--- 467,492 ----
  undo.o : undo.c buffer.h commands.h undo.h config.h 
  UNEXEC : config.h
  window.o : window.c indent.h commands.h window.h buffer.h config.h termchar.h
! xdisp.o : xdisp.c macros.h commands.h indent.h buffer.h dispextern.h termchar.h window.h config.h $(KANJI_H)
  xfns.o : xfns.c xterm.h window.h config.h
  xmenu.o : xmenu.c xterm.h window.h config.h
  xterm.o : xterm.c xterm.h termhooks.h termopts.h termchar.h \
!  dispextern.h config.h sink.h sinkmask.h $(KANJI_H)
  
! x11fns.o : x11fns.c window.h x11term.h dispextern.h termchar.h config.h $(KANJI_H)
  x11term.o : x11term.c x11term.h termhooks.h termopts.h termchar.h \
   dispextern.h config.h sink.h sinkmask.h
  
+ #ifdef EGG  /* 89.11.20 */ 
+ wnnfns.o : wnnfns.c $(KANJI_H)
+       $(CC) -c $(CFLAGS) $(WNNINC) wnnfns.c
+ #endif
+ 
  /* The files of Lisp proper */
  
! alloc.o : alloc.c window.h buffer.h config.h nconfig.h puresize.h
  bytecode.o : bytecode.c buffer.h config.h 
! data.o : data.c buffer.h config.h nconfig.h puresize.h
  eval.o : eval.c commands.h config.h
  fns.o : fns.c buffer.h commands.h config.h
  print.o : print.c process.h window.h buffer.h config.h 
